/*
 * =====================================================================================
 *
 *       Filename:  speech_recognize_response.h
 *
 *    Description:  speech recoginze response
 *
 *        Version:  1.0
 *        Created:  2021/1/21
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  jack.kj@alibaba-inc.com
 *
 * =====================================================================================
 */
#ifndef GAEA_AI_GAEA_ASR_SPEECH_RECOGNIZE_RESPONSE_H_
#define GAEA_AI_GAEA_ASR_SPEECH_RECOGNIZE_RESPONSE_H_

#include <string>

namespace gaea {
namespace asr {

class SpeechRecognizeResponse {
 public:
  explicit SpeechRecognizeResponse() = default;
  ~SpeechRecognizeResponse() = default;

  inline void set_content(const std::string& content) {
    content_ = content;
  }

  inline const std::string& content() const {
    return content_;
  }

 private:
  std::string content_;
};

} // namespace reflect
} // namespace gaea

#endif
